/**
 * Récupération du nom de la classe
 * https://www.stevefenton.co.uk/2013/04/Obtaining-A-Class-Name-At-Runtime-In-TypeScript/
 */
export class Describer {
    /**
     * Récupère le nom de la classe d'un objet
     * @param inputClass Objet à tester
     */
    public static getName(inputClass: any) {
        const funcNameRegex = /function (.{1,})\(/;
        const results = (funcNameRegex).exec((inputClass as any).constructor.toString());
        return (results && results.length > 1) ? results[1] : "";
    }
}
