import { Message, MessageCode } from "./message";

export class cLog {
    private _messages: Message[] = [];

    public add(m: Message) {
        this._messages.push(m);
    }

    public addLog(l: cLog) {
        for (let m of l._messages)
            this._messages.push(m);
    }

    /**
    * insert un message en début de liste
    */
    public insert(m: Message) {
        //arr.splice(index, 0, item); will insert item into arr at the specified index (deleting 0 items first, that is, it's just an insert).
        this._messages.splice(0, 0, m);
    }

    public get messages() {
        return this._messages;
    }

    public toString(): string {
        let res = "";
        for (let m of this._messages) {
            if (res != "")
                res += "\n";
            res += m.toString();
        }
        return res;
    }
}