/**
 * couple de valeurs non ordonnées
 */
export class Pair {
    protected _val1: number;
    protected _val2: number;

    constructor(v1: number, v2: number) {
        this.setValues(v1, v2);
    }

    get val1() {
        return this._val1;
    }

    get val2() {
        return this._val2;
    }

    setValues(v1: number, v2: number) {
        this._val1 = v1;
        this._val2 = v2;
    }

    setPair(p: Pair) {
        this.setValues(p._val1, p._val2);
    }

    undefine() {
        this._val1 = undefined;
        this._val2 = undefined;
    }

    get min() {
        return Math.min(this._val1, this._val2);
    }

    get max() {
        return Math.max(this._val1, this._val2);
    }

    intervalHasValue(v: number) {
        return this.min <= v && v <= this.max;
    }

    toString(): string {
        return "[" + this.min + "," + this.max + "]";
    }
}
